program CAL3
  use sep
  use tcai1

  implicit none

  integer 				:: n1,n2,n3
  integer 				:: n1_aux,n2_aux,n3_aux
  real					:: d1,d2,d3
  real 					:: d1_aux,d2_aux,d3_aux
  real 					:: o1,o2,o3
  real 					:: o1_aux,o2_aux,o3_aux
  integer				:: i1, i2, i3, iver, test, ioff, w1, wb, we
  integer				:: flength, iw
  logical                               :: auxi,ver
  real, dimension(:), allocatable	:: filt
  real, dimension(:,:), allocatable	:: zdata, zcali

  call sep_init()

! ----- calling parameters -------

  call from_history ("n1", n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)

  call from_history ("n2", n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2)

  call from_history ("n3", n3, 1)
  call from_history ("d3", d3, 1.0)
  call from_history ("o3", o3, 0.0)

  call from_aux	("filt","n1", n1_aux)

  call from_param( "verb", iver, 1); ver = (iver==1)

  call to_history ("o1", o1)
  call to_history ("d1", d1)
  call to_history ("n1", n1+n1_aux)

  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)

  call to_history ("o3", o3)
  call to_history ("d3", d3)
  call to_history ("n3", n3)

  call to_history("verb", iver)

  auxi = exist_file ("filt")

  call sep_close ()
! ----- end calling parameters -------

  if (.not. auxi) call seperr ("Need filter")

  if (ver) write(0,*) "files are okay"

! ----- allocating -------------

   
  if (allocated (zdata) ) deallocate (zdata)
  if (allocated (zcali) ) deallocate (zcali)
  if (allocated (filt) ) deallocate (filt)
   
if (ver) write(0,*) "Reserving space ..."

  allocate (zdata(n1,n2), STAT=test)
	if(test /=0) call seperr("cant allocate zdata")
  allocate (zcali(n1+n1_aux,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate zcali")
  allocate (filt(n1_aux),  STAT=test)
	if(test /=0) call seperr("cant allocate filt")

if (ver) write(0,*) "Done reserving space ..."

do i3=1,n3 !{

call sep_read(zdata)
call sep_read(filt,"filt")

 do i2=1,n2 !{

  call tcai1_lop(.false.,.false.,zdata(:,i2),zcali(:,i2),filt,n1_aux)
  call tcai1_close( )
 
 end do !}

call sep_write(zcali)

end do !}

deallocate( zdata, STAT=test)
if (test /=0) call seperr("cant deallocate zdata")
deallocate( zcali, STAT=test)
if (test /=0) call seperr("cant deallocate zcali")
deallocate( filt, STAT=test)
if (test /=0) call seperr("cant deallocate filt")

if (ver) write(0,*) "all done"

  call exit(0)
end program CAL3
