program LS_radial_trace
  use sep
  use velsimpx
  use solver_mod
  use cgstep_mod

  implicit none

  integer                          :: nt, nx, ns, iadj, n2, niter, stat
  real                             :: o1,d1, o2,d2, x0,dx, s0,ds,o3
  real, dimension (:), allocatable :: data, model, error
  logical                          :: adj

  call sep_init()
  call from_history (nt, n2)
  call from_either ("nx",nx,n2)
  call from_either ("ns",ns,2*nx)
  call from_history ("o3",o3)
  call from_history ("o1",o1)
  call from_history ("d1",d1)
  call from_either ("s0", s0) ; call from_either ("ds", ds)  
  call from_either ("x0", x0) ; call from_either ("dx", dx) 
  call from_par ("adj",iadj,1) ; adj = (iadj == 1)
  if (adj) then 
     call to_history ("label2","slowness(sec/km)")
     n2 = ns; o2 = s0; d2 = ds
  else
     call to_history ("label2","distance(km)")
     n2 = nx; o2 = x0; d2 = dx
  end if
  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)
  call from_par ("niter", niter, 10)
  if (exist_file ("error")) call to_history ("n1",niter,"error")
  call sep_close()

  allocate (data(nt*nx), model(nt*ns))

  call velsimpx_init (d1, d1, x0, dx, s0, ds, nt, nx, ns,o3)
  if (adj) then  
     allocate (error (niter))
     call sep_read (data)
     call solver (velsimpx_lop, cgstep, model, data, niter, verb = .true., err = error)
     call sep_write (model)
     if (exist_file ("error")) call sep_write (error/dot_product (data,data), "error")
     deallocate (error)
  else
     call sep_read (model)
     stat = velsimpx_lop (adj, .false., model, data)
     call sep_write (data)
  end if
  deallocate (model, data)
  call exit (0)
end program LS_radial_trace
