program RECDC
  use sep
  
  implicit none

  integer 				:: n1,n2,n3
  integer 				:: n1_aux,n2_aux,n3_aux
  real					:: d1,d2,d3
  real 					:: d1_aux,d2_aux,d3_aux
  real 					:: o1,o2,o3
  real 					:: o1_aux,o2_aux,o3_aux
  integer				:: i1, i2, i3, iver, test
  integer				:: iw, ioff, w1, wb, we, ikx
  logical                               :: auxi,ver
  real					:: amp, eps, wd, wv, sig1, sig2, Io
  real					:: deltat, stime, w, pi, w0, dw, kx0
  real					:: w2, vkx2, dkx, kx, dt
  complex				:: c
  real, dimension(:,:), allocatable	:: data
  complex, dimension(:,:), allocatable	:: dcmpx

  call sep_init()

! ----- calling parameters -------

  call from_history ("n1", n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)

  call from_history ("n2", n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2)

  call from_history ("n3", n3, 1)
  call from_history ("d3", d3, 1.0)
  call from_history ("o3", o3, 0.0)

  call from_param( "verb", iver, 1); ver = (iver==1)
  call from_param( "eps", eps, 0.00001)
  call from_param( "wd", wd, 118.0)
  call from_param( "wv", wv, 1500.0) 
  call from_param( "w1", w1, 10) 

  call to_history ("o1", o1)
  call to_history ("d1", d1)
  call to_history ("n1", n1)

  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)

  call to_history ("o3", o3)
  call to_history ("d3", d3)
  call to_history ("n3", n3)

  call to_history("verb", iver)

  call sep_close ()
! ----- end calling parameters -------

! ----- allocating -------------

   
  if (allocated (data) ) deallocate (data)
  if (allocated (dcmpx) ) deallocate (dcmpx)
   
if (ver) write(0,*) "Reserving space ..."

  allocate (data(n1,n2), STAT=test)
	if(test /=0) call seperr("cant allocate pdata")
  allocate (dcmpx(n1,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate pcmpx")

if (ver) write(0,*) "Done reserving space ..."

pi=3.14159265

sig1=+1.0
sig2=-1.0

do i3=1,n3 !{

 call sep_read(data)

 dcmpx = cmplx(data)

 call ft1axis(0,sig1,n1,n2,dcmpx)

 call ft2axis(0,sig2,n1,n2,dcmpx)

 w0 =-pi/d1; dw =2.*pi/(n1*d1)
 kx0=-pi/d2; dkx=2.*pi/(n2*d2)

 do iw=1,n1 !{

  w = w0+(iw-1)*dw

  do ikx=1,n2 !{

   kx = kx0+(ikx-1)*dkx
   w2 = w*w
   vkx2 = wv*wv*kx*kx
   dt = wd/wv

   if (w2 > vkx2) then
	c = cexp( cmplx(0.,-w*dt*sqrt(1. - vkx2/w2)) )
	dcmpx(iw,ikx)=dcmpx(iw,ikx)*c
   end if

  end do !}

 end do !}

 call ft1axis(1,sig1,n1,n2,dcmpx)

 call ft2axis(1,sig2,n1,n2,dcmpx)

 data=real(dcmpx)

 call sep_write(data)

end do !}

deallocate( data, STAT=test)
if (test /=0) call seperr("cant deallocate pdata")
deallocate( dcmpx, STAT=test)
if (test /=0) call seperr("cant deallocate pcmpx")

if (ver) write(0,*) "all done"

call exit(0)
end program RECDC
