program build_filter
  use sep
  use helix
  use createhelixmod
  use bound
 
  implicit none
  integer, dimension (:), allocatable :: n, a, center, gap
  integer                             :: dim, n123, i
  type( filter)                       :: aa   
  character (len = 6)                 :: varname

  call sep_init( SOURCE)
  dim = sep_dimension ()

  allocate( n(dim), center(dim), a(dim), gap(dim) )

  call from_history( n)
  call to_history( "n", n)

	a = 2;  center = 1;  gap = 0
 
  n123 = product (n)

  aa = createhelix( n, center, gap, a)     ! allocate filter
  call boundn( n, n, a, aa) 
	aa%lag = (/1,n(1),n(1)+1/)
!	aa%flt = (/-1,0,0/)
!	aa%flt = (/0,-1,0/)
	aa%flt = (/-1,-1,1/)

  call to_history ("n1", size( aa%lag))
  do i=2, dim
     call to_history (axisname(i),1)
  end do
  do i=1, size (aa%lag)
     if (i < 10) then
        write (varname,"(a,i1)") "lag",i
     else if (i < 100) then
        write (varname,"(a,i2)") "lag",i
     else
        write (varname,"(a,i3)") "lag",i
     end if
     call to_history_int (varname, aa%lag (i))
  end do
  call sep_write (aa%flt)
 
  call sep_close()

  deallocate (n, center, a, gap)
  call deallocatehelix( aa)

  call exit(0)

end program build_filter
