module filter_mod

 use ftu_mod
 use pad2_mod

contains

subroutine filter(p,z,n1,o1,d1,eps,st,fl,filt)

  implicit none

  integer		:: i1, iloc, fl, l1, lpad
  integer		:: b1, e1, sindx, n1
  real			:: st, eps, sign, d1, o1
  complex		:: pfilt(fl), zfilt(fl), c(fl)
  real, intent(in   )	:: p(n1), z(n1)
  real, intent(  out)	:: filt(fl)

! ---- get first sample /= 0 -------

 iloc = maxloc(abs(p),1)
! do i1=1,n1
!  if ( abs(p(i1)) > 0) then
!    iloc = i1
!    exit
!  end if
! end do

!write(0,*) "iloc", iloc

! ---- get the indexs for filt -----

 sindx = 1.5 + (st-o1)/d1
 b1=sindx+iloc; e1=sindx+iloc+fl
 if (b1 > n1)  b1=iloc
 if (e1 > n1)  e1=n1
 if (b1 == e1) b1=b1-1 
 l1 = e1-b1

!write(0,*) "b1,e1,sindx,l1", b1,e1,sindx,l1

! --- pad the filter - power of 2 --

 call pad2(l1,lpad)

 pfilt = cmplx(p(b1:e1))
 zfilt = cmplx(z(b1:e1))

 if (l1 < fl) then
  pfilt(e1+1:fl) = 0.
  zfilt(e1+1:fl) = 0.
 end if

!write(0,*) "-----PFILT-----"
!write(0,*) pfilt
!write(0,*) "---------------"
!write(0,*) "-----ZFILT-----"
!write(0,*) zfilt
!write(0,*) "---------------"

! -------- compute filter  ---------

 sign = +1.0
 call ftu(sign,fl,pfilt)
 call ftu(sign,fl,zfilt)

 c = (pfilt * conjg(zfilt))/(zfilt*conjg(zfilt) + eps*eps)
 call ftu(-sign,fl,c)
 filt=real(c)

write(0,*) "-----FILT-----"
write(0,*) filt
write(0,*) "---------------"

end subroutine filter

end module filter_mod
