module tcai1  
! Transient Convolution Adjoint Input 1-D. yy(m1+n1)
  use adj_mod
  implicit none
  integer	:: tt 
!  real ,private,  dimension (:)  :: bb 
  contains

!  subroutine tcai1_init(bb_in,blg)
!    integer		    :: blg
!    real ,   dimension(blg) :: bb_in 
!    write(0,*) "Inside init" 
!    bb = bb_in
!    write(0,*) "Done init" 
!  end subroutine

  subroutine tcai1_lop(adj,add,xx,yy,bb,blg)
    logical,intent(in)   :: adj,add 
    real, dimension (:)  :: xx 
    real, dimension (:)  :: yy 
    integer 		 :: b, x, y, blg
    real, dimension(blg) :: bb

    call adjnull (adj,add,xx,yy)
    if ( size(yy) < size (xx) + size(bb) - 1 ) then
      call erexit('tcai')
    end if
    do b= 1, size(bb)
      do x= 1, size(xx)
        y = x + b - 1
        if ( adj) then
          xx(x) =  xx(x) +  yy(y) * bb(b)
        else
          yy(y) =  yy(y) +  xx(x) * bb(b)
        end if
      end do
    end do
  end subroutine 
  subroutine tcai1_close()
  end subroutine 
end module 
