import string
import os

class cube:
    def __init__(self,head):
        self.head=head

    def init(self):
        self.headinit()
        self.headinfo()
        self.axes()
        self.size()

    def new(self):
        self.headinfo()
        self.axes()
        self.size()

    def report(self):
        print "-----------------------------------------------------------"
        print self.head
        try:
            print 'in='+self.binary
        except:
            print 'in='

        try:
            print '%s %1d'               % ("esize= ", self.esize)
        except:
            print '%s    '               % ("esize= ")

        try:    
            print '%s %5.3f %s'          % ("hsize=", self.hsize,self.sizeunit)
        except:
            print '%s         '          % ("hsize=")

        try:
            print '%s %5.3f %s %5.2f %s' % ("bsize=", self.bsize,self.sizeunit,self.psize,'%')
        except:
            print '%s                  ' % ("bsize=")
        print "-----------------------------------------------------------"
        print '       n        o             d           label'
        i=0
        while i<self.dim:
            try:
                print string.rjust( str(i+1), 2),
                print string.rjust(self.n[i],06),
                print string.rjust(self.o[i],13),
                print string.rjust(self.d[i],13),
                print string.rjust(self.l[i],10)
            except:
                print "" 
            i=i+1
        print "-----------------------------------------------------------"

    def headinit(self):
        # read a header file in a string
        f=open(self.head,'r')
        self.headfile=f.read()
        f.close()

        # convert the header string to a list
        self.headlist=string.split(self.headfile)

        # convert the header list to a dictionary
        self.headdict={}
        for arg in self.headlist:
            if "=" in arg:
                tmp=string.splitfields(arg,'=')
                self.headdict[tmp[0]]=tmp[1]

    def headinfo(self):
        self.esize =int(self.headdict['esize'])
        self.binary=self.headdict['in']
        self.binary=self.binary[1:len(self.binary)-1]

        self.dim=0;
        while 1:
            self.dim=self.dim+1
            nn='n'+str(self.dim)
            try:
                self.headdict[nn]
            except:
                self.dim=self.dim-1
                break

        i=self.dim
        while i>0:
            nn='n'+str(i)
            if int(self.headdict[nn]) <= 1:
                self.dim=self.dim-1
            else:
                break
            i=i-1

        self.dim = self.dim+1
        if(self.dim<5): self.dim=5
        
    def axes(self):
        self.n=range(self.dim)
        self.o=range(self.dim)
        self.d=range(self.dim)
        self.l=range(self.dim)

        self.elem=1;
        i=0
        while i<self.dim:
            nn='n'+str(i+1)
            try:
                self.n[i]=self.headdict[nn]
            except:
                self.n[i]=1

            oo='o'+str(i+1)
            try:
                self.o[i]=self.headdict[oo]
            except:
                self.o[i]=0.

            dd='d'+str(i+1)
            try:
                self.d[i]=self.headdict[dd]
            except:
                self.d[i]=1.

            ll='label'+str(i+1)
            try:
                self.l[i]=self.headdict[ll]
            except:
                self.l[i]=""

            self.elem=self.elem*int(self.n[i])

            i=i+1


    def size(self):

        coef=1.0
        self.sizeunit='b'

        testsize=float(self.elem)*float(self.esize)

        if testsize> 1024.0:
            coef=1.0/1024.0
            self.sizeunit='Kb'
        if testsize> 1024.0*1024.0:
            coef=1.0/1024.0/1024.0
            self.sizeunit='Mb'
        if testsize> 1024.0*1024.0*1024.0:
            coef=1.0/1024.0/1024.0/1024.0
            self.sizeunit='Gb'

        self.hsize=coef*testsize
        try:
            self.bsize=coef*os.path.getsize(self.binary)
        except:
            self.bsize=0.

        self.psize=self.bsize/self.hsize*100

    def writehead(self):
        f=open(self.head,'a')

        i=0
        while i<self.dim:
            nn='n'+str(i+1)
            buf = nn+"="+str(self.n[i])+"\n"
            f.write(buf)

            oo='o'+str(i+1)
            buf = oo+"="+str(self.o[i])+"\n"
            f.write(buf)

            dd='d'+str(i+1)
            buf = dd+"="+str(self.d[i])+"\n"
            f.write(buf)

            ll='label'+str(i+1)
            buf = ll+"="+str(self.l[i])+"\n"
            f.write(buf)

            f.write("\n")

            i=i+1

        f.close()
  
